/*++
  The material contained herein is not a license, either        
  expressly or impliedly, to any intellectual property owned    
  or controlled by any of the authors or developers of this     
  material or to any contribution thereto. The material         
  contained herein is provided on an "AS IS" basis and, to the  
  maximum extent permitted by applicable law, this information  
  is provided AS IS AND WITH ALL FAULTS, and the authors and    
  developers of this material hereby disclaim all other         
  warranties and conditions, either express, implied or         
  statutory, including, but not limited to, any (if any)        
  implied warranties, duties or conditions of merchantability,  
  of fitness for a particular purpose, of accuracy or           
  completeness of responses, of results, of workmanlike         
  effort, of lack of viruses and of lack of negligence, all     
  with regard to this material and any contribution thereto.    
  Designers must not rely on the absence or characteristics of  
  any features or instructions marked "reserved" or             
  "undefined." The Unified EFI Forum, Inc. reserves any         
  features or instructions so marked for future definition and  
  shall have no responsibility whatsoever for conflicts or      
  incompatibilities arising from future changes to them. ALSO,  
  THERE IS NO WARRANTY OR CONDITION OF TITLE, QUIET ENJOYMENT,  
  QUIET POSSESSION, CORRESPONDENCE TO DESCRIPTION OR            
  NON-INFRINGEMENT WITH REGARD TO THE TEST SUITE AND ANY        
  CONTRIBUTION THERETO.                                         
                                                                
  IN NO EVENT WILL ANY AUTHOR OR DEVELOPER OF THIS MATERIAL OR  
  ANY CONTRIBUTION THERETO BE LIABLE TO ANY OTHER PARTY FOR     
  THE COST OF PROCURING SUBSTITUTE GOODS OR SERVICES, LOST      
  PROFITS, LOSS OF USE, LOSS OF DATA, OR ANY INCIDENTAL,        
  CONSEQUENTIAL, DIRECT, INDIRECT, OR SPECIAL DAMAGES WHETHER   
  UNDER CONTRACT, TORT, WARRANTY, OR OTHERWISE, ARISING IN ANY  
  WAY OUT OF THIS OR ANY OTHER AGREEMENT RELATING TO THIS       
  DOCUMENT, WHETHER OR NOT SUCH PARTY HAD ADVANCE NOTICE OF     
  THE POSSIBILITY OF SUCH DAMAGES.                              
                                                                
  Copyright 2006, 2007, 2008, 2009, 2010 Unified EFI, Inc. All  
  Rights Reserved, subject to all existing rights in all        
  matters included within this Test Suite, to which United      
  EFI, Inc. makes no claim of right.                            
                                                                
  Copyright (c) 2010, Intel Corporation. All rights reserved.   
   
--*/
/*++

Module Name:
    HIIFontBBTestFunction.c

Abstract:
    for EFI Driver HII Font Protocol's function Test

--*/
#include "HIIFontBBTestMain.h"

extern UINT8 mPackageList1[];
extern UINT8 mPackageListTestFont[];

UINTN
StrLen (
    IN CHAR16   *s1
    );

UINTN
StrSize (
    IN CHAR16   *s1
    );

VOID
StrCpy (
    IN CHAR16   *Dest,
    IN CHAR16   *Src
    );

EFI_STATUS
BBTestStringToImageFunctionTestCheckpoint1 (
  IN EFI_STANDARD_TEST_LIBRARY_PROTOCOL         *StandardLib,
  IN EFI_HII_FONT_PROTOCOL                      *HIIFont
  );

EFI_STATUS
BBTestStringToImageFunctionTestCheckpoint2 (
  IN EFI_STANDARD_TEST_LIBRARY_PROTOCOL         *StandardLib,
  IN EFI_HII_FONT_PROTOCOL                      *HIIFont,
  IN EFI_GRAPHICS_OUTPUT_PROTOCOL               *GraphicsOutput
  );

EFI_STATUS
BBTestStringToImageFunctionTestCheckpoint3 (
  IN EFI_STANDARD_TEST_LIBRARY_PROTOCOL         *StandardLib,
  IN EFI_HII_FONT_PROTOCOL                      *HIIFont,
  IN EFI_GRAPHICS_OUTPUT_PROTOCOL               *GraphicsOutput
  );

EFI_STATUS
BBTestStringToImageFunctionTestCheckpoint4 (
  IN EFI_STANDARD_TEST_LIBRARY_PROTOCOL         *StandardLib,
  IN EFI_HII_DATABASE_PROTOCOL                  *HIIDatabase,
  IN EFI_HII_FONT_PROTOCOL                      *HIIFont,
  IN EFI_GRAPHICS_OUTPUT_PROTOCOL               *GraphicsOutput
  );

EFI_STATUS
BBTestStringToImageFunctionTestCheckpoint5 (
  IN EFI_STANDARD_TEST_LIBRARY_PROTOCOL         *StandardLib,
  IN EFI_HII_FONT_PROTOCOL                      *HIIFont,
  IN EFI_GRAPHICS_OUTPUT_PROTOCOL               *GraphicsOutput
  );

EFI_STATUS
BBTestStringToImageFunctionTestCheckpoint6 (
  IN EFI_STANDARD_TEST_LIBRARY_PROTOCOL         *StandardLib,
  IN EFI_HII_DATABASE_PROTOCOL                  *HIIDatabase,
  IN EFI_HII_FONT_PROTOCOL                      *HIIFont,
  IN EFI_GRAPHICS_OUTPUT_PROTOCOL               *GraphicsOutput
  );

EFI_STATUS
BBTestStringIdToImageFunctionTestCheckpoint1 (
  IN EFI_STANDARD_TEST_LIBRARY_PROTOCOL         *StandardLib,
  IN EFI_HII_DATABASE_PROTOCOL                  *HIIDatabase,
  IN EFI_HII_STRING_PROTOCOL                    *HIIString,
  IN EFI_HII_FONT_PROTOCOL                      *HIIFont
  );

EFI_STATUS
BBTestStringIdToImageFunctionTestCheckpoint2 (
  IN EFI_STANDARD_TEST_LIBRARY_PROTOCOL         *StandardLib,
  IN EFI_HII_DATABASE_PROTOCOL                  *HIIDatabase,
  IN EFI_HII_STRING_PROTOCOL                    *HIIString,
  IN EFI_HII_FONT_PROTOCOL                      *HIIFont,
  IN EFI_GRAPHICS_OUTPUT_PROTOCOL               *GraphicsOutput
  );

EFI_STATUS
BBTestGetGlyphFunctionTestCheckpoint1 (
  IN EFI_STANDARD_TEST_LIBRARY_PROTOCOL         *StandardLib,
  IN EFI_HII_FONT_PROTOCOL                      *HIIFont
  );

EFI_STATUS
BBTestGetFontInfoFunctionTestCheckpoint1 (
  IN EFI_STANDARD_TEST_LIBRARY_PROTOCOL         *StandardLib,
  IN EFI_HII_FONT_PROTOCOL                      *HIIFont
  );

EFI_STATUS
BBTestGetFontInfoFunctionTestCheckpoint2 (
  IN EFI_STANDARD_TEST_LIBRARY_PROTOCOL         *StandardLib,
  IN EFI_HII_FONT_PROTOCOL                      *HIIFont
  );

EFI_STATUS
BBTestStringToImageFunctionTest (
  IN EFI_BB_TEST_PROTOCOL       *This,
  IN VOID                       *ClientInterface,
  IN EFI_TEST_LEVEL             TestLevel,
  IN EFI_HANDLE                 SupportHandle
  )
{
  EFI_STANDARD_TEST_LIBRARY_PROTOCOL    *StandardLib;
  EFI_STATUS                            Status;
  EFI_HII_FONT_PROTOCOL                 *HIIFont;
  EFI_GRAPHICS_OUTPUT_PROTOCOL          *GraphicsOutput;
  EFI_HII_DATABASE_PROTOCOL             *HIIDatabase = NULL;


  //
  // init
  //
  HIIFont = (EFI_HII_FONT_PROTOCOL*)ClientInterface;

  //
  // Get the Standard Library Interface
  //
  Status = gtBS->HandleProtocol (
                   SupportHandle,
                   &gEfiStandardTestLibraryGuid,
                   &StandardLib
                   );
  if ( EFI_ERROR(Status) ) {
    return Status;
  }
  
  Status = GetHIIDatabaseInterface( &HIIDatabase );
  if ( EFI_ERROR(Status) ) {
    return Status;
  }

  Status = GetGraphicsOutputInterface ( &GraphicsOutput );
  if ( EFI_ERROR(Status) ) {
    return Status;
  }
  
  //
  //Call check points
  //
  BBTestStringToImageFunctionTestCheckpoint1 (StandardLib, HIIFont);

  BBTestStringToImageFunctionTestCheckpoint2 (StandardLib, HIIFont, GraphicsOutput);

  //
  // check point 3 check system font glyph
  //
  BBTestStringToImageFunctionTestCheckpoint3 (StandardLib, HIIFont, GraphicsOutput);

  // check point 4 check customized test font glyph
  BBTestStringToImageFunctionTestCheckpoint4 (StandardLib, HIIDatabase, HIIFont, GraphicsOutput);


  //
  // Now R9 code base HII font interface fails in check point 5, 6. And still not fixed yet
  // So temperally remove these two checkpoints
  //
  
  //
  // check point 5 test RowInfoArray / RowInfoArraySize / ColumnInfoArray with sysinfo == NULL
  //
  //BBTestStringToImageFunctionTestCheckpoint5 (StandardLib, HIIFont, GraphicsOutput);

  
  // check point 6 test RowInfoArray / RowInfoArraySize / ColumnInfoArray with sysinfo != NULL
  //BBTestStringToImageFunctionTestCheckpoint6 (StandardLib, HIIDatabase, HIIFont, GraphicsOutput);

  
  return EFI_SUCCESS;
}


EFI_STATUS
BBTestStringIdToImageFunctionTest (
  IN EFI_BB_TEST_PROTOCOL       *This,
  IN VOID                       *ClientInterface,
  IN EFI_TEST_LEVEL             TestLevel,
  IN EFI_HANDLE                 SupportHandle
  )
{
  EFI_STANDARD_TEST_LIBRARY_PROTOCOL    *StandardLib;
  EFI_STATUS                            Status;
  EFI_HII_FONT_PROTOCOL                 *HIIFont;
  EFI_HII_STRING_PROTOCOL               *HIIString;
  EFI_HII_DATABASE_PROTOCOL             *HIIDatabase;
  EFI_GRAPHICS_OUTPUT_PROTOCOL          *GraphicsOutput;

  //
  // init
  //
  HIIFont = (EFI_HII_FONT_PROTOCOL*)ClientInterface;

  //
  // Get the Standard Library Interface
  //
  Status = gtBS->HandleProtocol (
                   SupportHandle,
                   &gEfiStandardTestLibraryGuid,
                   &StandardLib
                   );
  if ( EFI_ERROR(Status) ) {
    return Status;
  }
  
  Status = GetHIIDatabaseInterface( &HIIDatabase );
  if ( EFI_ERROR(Status) ) {
    return Status;
  }

  Status = GetHIIStringInterface ( &HIIString );
  if ( EFI_ERROR(Status) ) {
    return Status;
  }

  Status = GetGraphicsOutputInterface ( &GraphicsOutput );
  if ( EFI_ERROR(Status) ) {
    return Status;
  }
  
  //
  //Call check points
  //
  BBTestStringIdToImageFunctionTestCheckpoint1 (StandardLib, HIIDatabase, HIIString, HIIFont);

  BBTestStringIdToImageFunctionTestCheckpoint2 (StandardLib, HIIDatabase, HIIString, HIIFont, GraphicsOutput);
  
  return EFI_SUCCESS;
}


EFI_STATUS
BBTestGetGlyphFunctionTest (
  IN EFI_BB_TEST_PROTOCOL       *This,
  IN VOID                       *ClientInterface,
  IN EFI_TEST_LEVEL             TestLevel,
  IN EFI_HANDLE                 SupportHandle
  )
{
  EFI_STANDARD_TEST_LIBRARY_PROTOCOL    *StandardLib;
  EFI_STATUS                            Status;
  EFI_HII_FONT_PROTOCOL                 *HIIFont;

  //
  // init
  //
  HIIFont = (EFI_HII_FONT_PROTOCOL*)ClientInterface;

  //
  // Get the Standard Library Interface
  //
  Status = gtBS->HandleProtocol (
                   SupportHandle,
                   &gEfiStandardTestLibraryGuid,
                   &StandardLib
                   );
  if ( EFI_ERROR(Status) ) {
    return Status;
  }

  //
  //Call check points
  //

  BBTestGetGlyphFunctionTestCheckpoint1 (StandardLib, HIIFont);
  
  return EFI_SUCCESS;
}


EFI_STATUS
BBTestGetFontInfoFunctionTest (
  IN EFI_BB_TEST_PROTOCOL       *This,
  IN VOID                       *ClientInterface,
  IN EFI_TEST_LEVEL             TestLevel,
  IN EFI_HANDLE                 SupportHandle
  )
{
  EFI_STANDARD_TEST_LIBRARY_PROTOCOL    *StandardLib;
  EFI_STATUS                            Status;
  EFI_HII_FONT_PROTOCOL                 *HIIFont;

  //
  // init
  //
  HIIFont = (EFI_HII_FONT_PROTOCOL*)ClientInterface;

  //
  // Get the Standard Library Interface
  //
  Status = gtBS->HandleProtocol (
                   SupportHandle,
                   &gEfiStandardTestLibraryGuid,
                   &StandardLib
                   );
  if ( EFI_ERROR(Status) ) {
    return Status;
  }

  //
  //Call check points
  //
  BBTestGetFontInfoFunctionTestCheckpoint1 (StandardLib, HIIFont);

  BBTestGetFontInfoFunctionTestCheckpoint2 (StandardLib, HIIFont);
  
  return EFI_SUCCESS;
}



EFI_STATUS
BBTestStringToImageFunctionTestCheckpoint1 (
  IN EFI_STANDARD_TEST_LIBRARY_PROTOCOL         *StandardLib,
  IN EFI_HII_FONT_PROTOCOL                      *HIIFont
  )
{
  EFI_STATUS            Status;
  EFI_TEST_ASSERTION    AssertionType;
  
  EFI_STRING               TestString;
  EFI_FONT_DISPLAY_INFO    *StringInfo;
  EFI_IMAGE_OUTPUT         *Blt;
  UINTN                    BltX;
  UINTN                    BltY;
  EFI_HII_ROW_INFO         **RowInfoArray = NULL;
  UINTN                    *RowInfoArraySize = NULL;
  UINTN                    *ColumnInfoArray = NULL;
  UINTN                    Index = 0;
  
  //
  // Init the Flags, String, StringInfo, Blt
  //
  EFI_HII_OUT_FLAGS ValidFlags[] = {
    EFI_HII_OUT_FLAG_CLIP, 
    EFI_HII_OUT_FLAG_WRAP,
    EFI_HII_OUT_FLAG_CLIP_CLEAN_Y | EFI_HII_OUT_FLAG_CLIP,
    EFI_HII_OUT_FLAG_CLIP_CLEAN_X | EFI_HII_OUT_FLAG_CLIP,
    EFI_HII_OUT_FLAG_TRANSPARENT,
    EFI_HII_IGNORE_IF_NO_GLYPH,
    EFI_HII_IGNORE_LINE_BREAK,
    0
  };
  Blt = (EFI_IMAGE_OUTPUT *) AllocateZeroPool (sizeof(EFI_IMAGE_OUTPUT));
  if ( Blt == NULL ){
    return  EFI_UNSUPPORTED;
  }

  Blt->Width = 50;
  Blt->Height = 40;
  
  Blt->Image.Bitmap = (EFI_GRAPHICS_OUTPUT_BLT_PIXEL *)AllocateZeroPool (Blt->Width * Blt->Height * sizeof(EFI_GRAPHICS_OUTPUT_BLT_PIXEL));
  if ( Blt->Image.Bitmap == NULL ){
  	gtBS->FreePool (Blt);
    return  EFI_UNSUPPORTED;
  }
  
  TestString = L"TestString";
  StringInfo = NULL;
  BltX = 0;
  BltY = 0;

  //
  // Call HIIFont->StringToImage with valid parameters
  //
  for ( Index = 0; ValidFlags[Index] != 0; Index++ ){
    Status = HIIFont->StringToImage (
                        HIIFont,
                        ValidFlags[Index],
                        TestString,
                        StringInfo,
                        &Blt,
                        BltX,
                        BltY,
                        RowInfoArray,
                        RowInfoArraySize,
                        ColumnInfoArray
                        );
                            

    if ( EFI_SUCCESS != Status ) {
      AssertionType = EFI_TEST_ASSERTION_FAILED;
    } else {
      AssertionType = EFI_TEST_ASSERTION_PASSED;
    }
    StandardLib->RecordAssertion (
                   StandardLib,
                   AssertionType,
                   gHIIFontBBTestFunctionAssertionGuid001,
                   L"HII_FONT_PROTOCOL.StringToImage - StringToImage() returns EFI_SUCCESS with valid parameters.",
                   L"%a:%d: Status - %r",
                   __FILE__,
                   (UINTN)__LINE__,
                   Status
                   );

	if ( RowInfoArray != NULL )
		gtBS->FreePool (RowInfoArray);
  }

  gtBS->FreePool (Blt->Image.Bitmap);
  gtBS->FreePool (Blt);
  
  return EFI_SUCCESS;
}


EFI_STATUS
BBTestStringToImageFunctionTestCheckpoint2 (
  IN EFI_STANDARD_TEST_LIBRARY_PROTOCOL         *StandardLib,
  IN EFI_HII_FONT_PROTOCOL                      *HIIFont,
  IN EFI_GRAPHICS_OUTPUT_PROTOCOL               *GraphicsOutput
  )
{
  EFI_STATUS            Status;
  EFI_TEST_ASSERTION    AssertionType;
  
  EFI_STRING               TestString;
  EFI_FONT_DISPLAY_INFO    *StringInfo;
  EFI_IMAGE_OUTPUT         *Blt;
  UINTN                    BltX;
  UINTN                    BltY;
  EFI_HII_ROW_INFO         **RowInfoArray = NULL;
  UINTN                    *RowInfoArraySize = NULL;
  UINTN                    *ColumnInfoArray = NULL;
  UINTN                    Index = 0;

  
  UINT32                   HorizontalResolution;
  UINT32                   VerticalResolution;
  
  //
  // Init the Flags, String, StringInfo, Blt
  //
  EFI_HII_OUT_FLAGS ValidFlags[] = {
    EFI_HII_OUT_FLAG_CLIP | EFI_HII_DIRECT_TO_SCREEN, 
    EFI_HII_OUT_FLAG_WRAP | EFI_HII_DIRECT_TO_SCREEN,
    EFI_HII_OUT_FLAG_CLIP_CLEAN_Y | EFI_HII_OUT_FLAG_CLIP | EFI_HII_DIRECT_TO_SCREEN,
    EFI_HII_OUT_FLAG_CLIP_CLEAN_X | EFI_HII_OUT_FLAG_CLIP | EFI_HII_DIRECT_TO_SCREEN,
    EFI_HII_IGNORE_IF_NO_GLYPH | EFI_HII_DIRECT_TO_SCREEN,
    EFI_HII_IGNORE_LINE_BREAK | EFI_HII_DIRECT_TO_SCREEN,
    EFI_HII_DIRECT_TO_SCREEN,
    0
  };

  if ( GraphicsOutput != NULL ) {
    HorizontalResolution = GraphicsOutput->Mode->Info->HorizontalResolution;
    VerticalResolution = GraphicsOutput->Mode->Info->VerticalResolution;
  } else {
    return EFI_UNSUPPORTED;
  }

  Blt = (EFI_IMAGE_OUTPUT *) AllocateZeroPool (sizeof(EFI_IMAGE_OUTPUT));
  if ( Blt == NULL ){
    return  EFI_UNSUPPORTED;
  }
  
  Blt->Width = (UINT16) (HorizontalResolution);
  Blt->Height = (UINT16) (VerticalResolution);
  Blt->Image.Screen = GraphicsOutput;
  TestString = L"TestString";
  StringInfo = NULL;
  BltX = 0;
  BltY = 0;

  //
  // Call HIIFont->StringToImage with valid parameters
  //
  for ( Index = 0; ValidFlags[Index] != 0; Index++ ){
    Status = HIIFont->StringToImage (
                        HIIFont,
                        ValidFlags[Index],
                        TestString,
                        StringInfo,
                        &Blt,
                        BltX,
                        BltY,
                        RowInfoArray,
                        RowInfoArraySize,
                        ColumnInfoArray
                        );
                            

    if ( EFI_SUCCESS != Status ) {
      AssertionType = EFI_TEST_ASSERTION_FAILED;
    } else {
      AssertionType = EFI_TEST_ASSERTION_PASSED;
    }
    StandardLib->RecordAssertion (
                   StandardLib,
                   AssertionType,
                   gHIIFontBBTestFunctionAssertionGuid002,
                   L"HII_FONT_PROTOCOL.StringToImage - StringToImage() returns EFI_SUCCESS with valid parameters.",
                   L"%a:%d: Status - %r",
                   __FILE__,
                   (UINTN)__LINE__,
                   Status
                   );

	if ( RowInfoArray != NULL )
		gtBS->FreePool (RowInfoArray);
  }

  gtBS->FreePool (Blt);
  
  return EFI_SUCCESS;
}


static INTN
CompareMem (
  IN VOID     *Dest,
  IN VOID     *Src,
  IN UINTN    len
  )
/*++

Routine Description:
  Compares the contents of one buffer to another.

Arguments:
  Dest                - A pointer to the buffer to compare

  Src                 - A pointer to the buffer to compare

  len                 - The number of bytes to compare

Returns:

  0                   - Dest is identical to Src for len bytes.
  !=0                 - Dest is not identical to Src for len bytes.

--*/
{
  CHAR8 *d;

  CHAR8 *s;

  ASSERT (Dest != NULL);
  ASSERT (Src != NULL);

  d = Dest;
  s = Src;
  while (len--) {
    if (*d != *s) {
      return *d -*s;
    }

    d += 1;
    s += 1;
  }

  return 0;
}

EFI_STATUS
BBTestStringToImageFunctionTestCheckpoint3 (
  IN EFI_STANDARD_TEST_LIBRARY_PROTOCOL         *StandardLib,
  IN EFI_HII_FONT_PROTOCOL                      *HIIFont,
  IN EFI_GRAPHICS_OUTPUT_PROTOCOL               *GraphicsOutput
  )
{
  EFI_STATUS               Status;
  EFI_TEST_ASSERTION       AssertionType;
  CHAR16                   TestString[2];
  EFI_FONT_DISPLAY_INFO    *StringInfo = NULL;
  EFI_IMAGE_OUTPUT         *Blt;
  EFI_IMAGE_OUTPUT         *FontGlyphBlt = NULL;
  UINTN                    BltX;
  UINTN                    BltY;
  EFI_HII_ROW_INFO         **RowInfoArray = NULL;
  UINTN                    *RowInfoArraySize = NULL;
  UINTN                    *ColumnInfoArray = NULL;
  UINT32                   HorizontalResolution;
  UINT32                   VerticalResolution;
  UINTN                    BaseLine;
  BOOLEAN                  GlyPhMismatch = FALSE;
  
  if ( GraphicsOutput != NULL ) {
    HorizontalResolution = GraphicsOutput->Mode->Info->HorizontalResolution;
    VerticalResolution = GraphicsOutput->Mode->Info->VerticalResolution;
  } else {
    return EFI_UNSUPPORTED;
  }

  Blt = (EFI_IMAGE_OUTPUT *) AllocateZeroPool (sizeof(EFI_IMAGE_OUTPUT));
  if ( Blt == NULL ){
  	 StandardLib->RecordAssertion (
                   StandardLib,
                   EFI_TEST_ASSERTION_FAILED,
                   gTestGenericFailureGuid,
                   L"AllocateZeroPool fail",
                   L"%a:%d: ",
                   __FILE__,
                   (UINTN)__LINE__
                   );
    return  EFI_UNSUPPORTED;
  }
 
  TestString[1] = L'\0';
  
  //
  // test ASCII letter glyph from ' ' to '~'
  // 
  for (TestString[0] = L' '; TestString[0] <= L'~'; TestString[0]++) {
    do {
      //
      // get charater sysetem default Glyph Image Buffer 
      //
      FontGlyphBlt = NULL;
      
      Status = HIIFont->GetGlyph (
                          HIIFont,
                          TestString[0],
                          NULL,
                          &FontGlyphBlt,
                          &BaseLine
                          );              
      if (Status != EFI_SUCCESS) { 
        StandardLib->RecordAssertion (
                     StandardLib,
                     EFI_TEST_ASSERTION_FAILED,
                     gTestGenericFailureGuid,
                     L"GetGlyph fail",
                     L"%a:%d: Status - %r",
                     __FILE__,
                     (UINTN)__LINE__,
                     Status
                     );
        break;
      }
  
      //
      // Print charater system default Glyph to image buffer
      //
      Blt->Width = FontGlyphBlt->Width;
      Blt->Height = FontGlyphBlt->Height;
      Blt->Image.Bitmap = (EFI_GRAPHICS_OUTPUT_BLT_PIXEL *)AllocateZeroPool (sizeof(EFI_GRAPHICS_OUTPUT_BLT_PIXEL) * Blt->Width * Blt->Height);
      StringInfo = NULL;
      BltX = 0;
      BltY = 0;
  
      if (Blt->Image.Bitmap == NULL) {
        StandardLib->RecordAssertion (
                      StandardLib,
                      EFI_TEST_ASSERTION_FAILED,
                      gTestGenericFailureGuid,
                      L"GetFontInfo fail",
                      L"%a:%d: Status - %r",
                      __FILE__,
                      (UINTN)__LINE__,
                      Status
                      );
        break;
      }
      
      Status = HIIFont->StringToImage (
                          HIIFont,
                          EFI_HII_DRAW_FLAG_DEFAULT,
                          TestString,
                          StringInfo,
                          &Blt,
                          BltX,
                          BltY,
                          RowInfoArray,
                          RowInfoArraySize,
                          ColumnInfoArray
                          );

      //
      // Compare with the image buffer from GetGlyph & StringToImage
      //
      if (CompareMem(
      	     FontGlyphBlt->Image.Bitmap, 
      	     Blt->Image.Bitmap, 
      	     sizeof(EFI_GRAPHICS_OUTPUT_BLT_PIXEL) * Blt->Width * Blt->Height)) {
        GlyPhMismatch = TRUE;
      }
    }while (0);
    
    if (FontGlyphBlt != NULL) {
      FreePool(FontGlyphBlt);
      FontGlyphBlt = NULL;
    }   

    if ( RowInfoArray != NULL ) {
      FreePool (RowInfoArray);
      RowInfoArray = NULL;
    }
     
    if (Blt->Image.Bitmap != NULL) {
      FreePool(Blt->Image.Bitmap);
      Blt->Image.Bitmap = NULL;
    }
    
    if (GlyPhMismatch == TRUE) {
      break;
    }
  }

  if (GlyPhMismatch == TRUE) {
    AssertionType = EFI_TEST_ASSERTION_FAILED;
  } else {
    AssertionType = EFI_TEST_ASSERTION_PASSED;
  }

  StandardLib->RecordAssertion (
                   StandardLib,
                   AssertionType,
                   gHIIFontBBTestFunctionAssertionGuid008,
                   L"HII_FONT_PROTOCOL.StringToImage - StringToImage() returns EFI_SUCCESS with valid parameters.",
                   L"%a:%d: ",
                   __FILE__,
                   (UINTN)__LINE__
                   );

  if (Blt != NULL) {
    FreePool (Blt);
  }
  
  return EFI_SUCCESS;
}


EFI_STATUS
BBTestStringToImageFunctionTestCheckpoint4 (
  IN EFI_STANDARD_TEST_LIBRARY_PROTOCOL         *StandardLib,
  IN EFI_HII_DATABASE_PROTOCOL                  *HIIDatabase,
  IN EFI_HII_FONT_PROTOCOL                      *HIIFont,
  IN EFI_GRAPHICS_OUTPUT_PROTOCOL               *GraphicsOutput
  )
{
  EFI_STATUS                            Status;
  EFI_TEST_ASSERTION                    AssertionType;
  CHAR16                                TestString[2];
  EFI_FONT_DISPLAY_INFO                 *StringInfo = NULL;
  UINTN                                 InfoSize;
  EFI_IMAGE_OUTPUT                      *Blt = NULL;
  EFI_IMAGE_OUTPUT                      *FontGlyphBlt = NULL;
  UINTN                                 BltX;
  UINTN                                 BltY;
  EFI_HII_ROW_INFO                      **RowInfoArray = NULL;
  UINTN                                 *RowInfoArraySize = NULL;
  UINTN                                 *ColumnInfoArray = NULL;
  UINT32                                HorizontalResolution;
  UINT32                                VerticalResolution;
  UINTN                                 BaseLine;
  EFI_HII_PACKAGE_LIST_HEADER           *PackageList = NULL;
  EFI_HII_HANDLE                        HiiHandle = NULL;
  BOOLEAN                               GlyPhMismatch = FALSE;
  
  
  if ( GraphicsOutput != NULL ) {
    HorizontalResolution = GraphicsOutput->Mode->Info->HorizontalResolution;
    VerticalResolution = GraphicsOutput->Mode->Info->VerticalResolution;
  } else {
    return EFI_UNSUPPORTED;
  }

  //
  // Add the PackageList to the HII database to get a EFI_HII_HANDLE
  //
  PackageList = (EFI_HII_PACKAGE_LIST_HEADER*)mPackageListTestFont;

  Status = HIIDatabase->NewPackageList(
                          HIIDatabase,
                          PackageList,
                          NULL,
                          &HiiHandle
                          );
  if ( EFI_ERROR(Status) ) {
  	 StandardLib->RecordAssertion (
                   StandardLib,
                   EFI_TEST_ASSERTION_FAILED,
                   gTestGenericFailureGuid,
                   L"Test font packetlist add fail",
                   L"%a:%d: ",
                   __FILE__,
                   (UINTN)__LINE__
                   );
    return EFI_LOAD_ERROR;
  }

  InfoSize = sizeof (EFI_FONT_DISPLAY_INFO) - sizeof (CHAR16) + StrSize (L"testfont");
  StringInfo = (EFI_FONT_DISPLAY_INFO *) AllocateZeroPool (InfoSize);
  if (StringInfo == NULL) {
  	 StandardLib->RecordAssertion (
                   StandardLib,
                   EFI_TEST_ASSERTION_FAILED,
                   gTestGenericFailureGuid,
                   L"AllocateZeroPool fail",
                   L"%a:%d: ",
                   __FILE__,
                   (UINTN)__LINE__
                   );
    goto EXIT;  	  
  }
  
  StringInfo->BackgroundColor.Blue = 0xFF;
  StringInfo->BackgroundColor.Red  = 0x00;
  StringInfo->BackgroundColor.Green= 0x00;
  
  StringInfo->ForegroundColor.Blue = 0x00;
  StringInfo->ForegroundColor.Red  = 0x00;
  StringInfo->ForegroundColor.Green= 0xFF;
  
  StringInfo->FontInfoMask = EFI_FONT_INFO_ANY_STYLE;

  StringInfo->FontInfo.FontSize = 19;
  StringInfo->FontInfo.FontStyle = 0;  
  StrCpy (StringInfo->FontInfo.FontName, L"testfont");
  
  Blt = (EFI_IMAGE_OUTPUT *) AllocateZeroPool (sizeof(EFI_IMAGE_OUTPUT));
  if ( Blt == NULL ){
  	 StandardLib->RecordAssertion (
                   StandardLib,
                   EFI_TEST_ASSERTION_FAILED,
                   gTestGenericFailureGuid,
                   L"AllocateZeroPool fail",
                   L"%a:%d: ",
                   __FILE__,
                   (UINTN)__LINE__
                   );
    goto EXIT;  	  
  }
 
  TestString[1] = L'\0';
  
  //
  // test ASCII letter glyph from ' ' to '~'
  // 
  for (TestString[0] = L' '; TestString[0] <= L'~'; TestString[0]++) {
    do {
      //
      // get charater sysetem default Glyph Image Buffer 
      //
      
      Status = HIIFont->GetGlyph (
                          HIIFont,
                          TestString[0],
                          StringInfo,
                          &FontGlyphBlt,
                          &BaseLine
                          );              
      if (Status != EFI_SUCCESS) { 
        StandardLib->RecordAssertion (
                     StandardLib,
                     EFI_TEST_ASSERTION_FAILED,
                     gTestGenericFailureGuid,
                     L"GetGlyph fail",
                     L"%a:%d: Status - %r",
                     __FILE__,
                     (UINTN)__LINE__,
                     Status
                     );
        break;
      }
  
      //
      // Print charater system default Glyph to image buffer
      //
      Blt->Width = FontGlyphBlt->Width;
      Blt->Height = FontGlyphBlt->Height;
      Blt->Image.Bitmap = (EFI_GRAPHICS_OUTPUT_BLT_PIXEL *)AllocateZeroPool (sizeof(EFI_GRAPHICS_OUTPUT_BLT_PIXEL) * Blt->Width * Blt->Height);
      BltX = 0;
      BltY = 0;
  
      if (Blt->Image.Bitmap == NULL) {
        StandardLib->RecordAssertion (
                      StandardLib,
                      EFI_TEST_ASSERTION_FAILED,
                      gTestGenericFailureGuid,
                      L"GetFontInfo fail",
                      L"%a:%d: Status - %r",
                      __FILE__,
                      (UINTN)__LINE__,
                      Status
                      );
        break;
      }
      
      Status = HIIFont->StringToImage (
                          HIIFont,
                          EFI_HII_DRAW_FLAG_DEFAULT,
                          TestString,
                          StringInfo,
                          &Blt,
                          BltX,
                          BltY,
                          RowInfoArray,
                          RowInfoArraySize,
                          ColumnInfoArray
                          );

      //
      // Compare with the image buffer from GetGlyph & StringToImage
      //
      if (CompareMem(
      	     FontGlyphBlt->Image.Bitmap, 
      	     Blt->Image.Bitmap, 
      	     sizeof(EFI_GRAPHICS_OUTPUT_BLT_PIXEL) * Blt->Width * Blt->Height)) {
        GlyPhMismatch = TRUE;
      }
    }while (0);
    
    if (FontGlyphBlt != NULL) {
      FreePool(FontGlyphBlt);
      FontGlyphBlt = NULL;
    }   

    if ( RowInfoArray != NULL ) {
      FreePool (RowInfoArray);
      RowInfoArray = NULL;
    }
     
    if (Blt->Image.Bitmap != NULL) {
      FreePool(Blt->Image.Bitmap);
      Blt->Image.Bitmap = NULL;
    }
    
    if (GlyPhMismatch == TRUE) {
      break;
    }
  }

  if (GlyPhMismatch == TRUE) {
    AssertionType = EFI_TEST_ASSERTION_FAILED;
  } else {
    AssertionType = EFI_TEST_ASSERTION_PASSED;
  }

  StandardLib->RecordAssertion (
                   StandardLib,
                   AssertionType,
                   gHIIFontBBTestFunctionAssertionGuid023,
                   L"HII_FONT_PROTOCOL.StringToImage - StringToImage() returns EFI_SUCCESS with valid parameters.",
                   L"%a:%d: ",
                   __FILE__,
                   (UINTN)__LINE__
                   );

EXIT:
	 //
  // remove test font package
  //
  if (HiiHandle != NULL) {
    HIIDatabase->RemovePackageList (
                   HIIDatabase,
                   HiiHandle
                   );
  }

  if (StringInfo != NULL) {
    FreePool (StringInfo);
  }
    
  if (Blt != NULL) {
    FreePool (Blt);
  }

  return EFI_SUCCESS;
}


EFI_STATUS
BBTestStringToImageFunctionTestCheckpoint5 (
  IN EFI_STANDARD_TEST_LIBRARY_PROTOCOL         *StandardLib,
  IN EFI_HII_FONT_PROTOCOL                      *HIIFont,
  IN EFI_GRAPHICS_OUTPUT_PROTOCOL               *GraphicsOutput
  )
{
  EFI_STATUS               Status;
  EFI_TEST_ASSERTION       AssertionType;
  EFI_STRING               TestString = NULL;
  EFI_FONT_DISPLAY_INFO    *StringInfo = NULL;
  EFI_IMAGE_OUTPUT         *Blt = NULL;
  UINTN                    BltX;
  UINTN                    BltY;
  EFI_HII_ROW_INFO         *RowInfoArray = NULL;
  UINTN                    RowInfoArraySize;
  UINTN                    *ColumnInfoArray = NULL;
  UINT32                   HorizontalResolution;
  UINT32                   VerticalResolution;
  UINT32                   Index;
  UINT16                   TestFontHeight, TestFontWidth;
  UINT32                   StrLen;
  
  if ( GraphicsOutput != NULL ) {
    HorizontalResolution = GraphicsOutput->Mode->Info->HorizontalResolution;
    VerticalResolution = GraphicsOutput->Mode->Info->VerticalResolution;
  } else {
    return EFI_UNSUPPORTED;
  }

  //
  // UEFI describes a standard font, which is required for all systems which support
  // text display on bitmapped output devices. The standard font (named 'system') 
  // is a fixed pitch font, where all characters are either narrow (8x19) or wide (16x19).
  //
  //
  //Points to the string output information, including the color and font. If NULL, then the
  //string will be output in the default system font and color.
  // 
  // Get Character 'T'  default system font as test character  
  //
  Status = HIIFont->GetGlyph (
  	                   HIIFont,
                      L'T',
                      NULL,
                      &Blt,
                      NULL
  	                   );
  if ( EFI_SUCCESS != Status ) {
    StandardLib->RecordAssertion (
                   StandardLib,
                   EFI_TEST_ASSERTION_FAILED,
                   gTestGenericFailureGuid,
                   L"GetGlyph fail",
                   L"%a:%d: Status - %r",
                   __FILE__,
                   (UINTN)__LINE__,
                   Status
                   );
    return Status;
  }

  TestFontHeight = Blt->Height;
  TestFontWidth  = Blt->Width;
  FreePool(Blt);
  Blt = NULL;

  //
  // Construct test string dynamically according to screen size  ( 4~5 charaters longer than screen width)
  // 
  TestString = (EFI_STRING)AllocateZeroPool(sizeof(L'T') * (HorizontalResolution / TestFontWidth + 5));
  if (TestString == NULL) {
    StandardLib->RecordAssertion (
                   StandardLib,
                   EFI_TEST_ASSERTION_FAILED,
                   gTestGenericFailureGuid,
                   L"AllocateZeroPool fail",
                   L"%a:%d: ",
                   __FILE__,
                   (UINTN)__LINE__
                   );
    goto EXIT;
  }
  
  StrLen = HorizontalResolution / TestFontWidth + 4;
  for (Index = 0; Index < StrLen; Index++) {
    TestString[Index] = L'T';
  }

  Blt = (EFI_IMAGE_OUTPUT *) AllocateZeroPool (sizeof(EFI_IMAGE_OUTPUT));
  if ( Blt == NULL ){
    goto EXIT;
  }

  //
  // 1. Check EFI_HII_DIRECT_TO_SCREEN only case
  // If Blt is not NULL, then EFI_HII_OUT_FLAG_CLIP is implied  
  // String is designed to displayed with one full line
  //
  Blt->Width = (UINT16) (HorizontalResolution);
  Blt->Height = (UINT16) (VerticalResolution);
  Blt->Image.Screen = GraphicsOutput; 
  StringInfo = NULL;

  BltX = 0;
  BltY = VerticalResolution - 3 * TestFontHeight;
  Status = HIIFont->StringToImage (
                      HIIFont,
                      EFI_HII_DIRECT_TO_SCREEN,
                      TestString,
                      StringInfo,
                      &Blt,
                      BltX,
                      BltY,
                      &RowInfoArray,
                      &RowInfoArraySize,
                      ColumnInfoArray
                      );
  
  //
  // For the final row, the RowInfoArray.LineHeight and RowInfoArray.BaseLine may describe pixels
  // which are outside the limit specified by Blt. Height (unless EFI_HII_OUT_FLAG_CLIP_CLEAN_Y 
  // is specified) even though those pixels were not drawn.
  //
  if (EFI_SUCCESS == Status 
  	&& RowInfoArraySize == 1    	
   && RowInfoArray != NULL
   && RowInfoArray[0].BaselineOffset == 0 
   && RowInfoArray[0].LineHeight == TestFontHeight
   && RowInfoArray[0].LineWidth == Blt->Width
   && ColumnInfoArray != NULL) {
    AssertionType = EFI_TEST_ASSERTION_PASSED;
  } else {
    AssertionType = EFI_TEST_ASSERTION_FAILED;
  }

  StandardLib->RecordAssertion (
                 StandardLib,
                 AssertionType,
                 gHIIFontBBTestFunctionAssertionGuid009,
                 L"HII_FONT_PROTOCOL.StringToImage - StringToImage() EFI_HII_DIRECT_TO_SCREEN fails.",
                 L"%a:%d: Status - %r",
                 __FILE__,
                 (UINTN)__LINE__,
                 Status
                 );
  if (RowInfoArray != NULL) {
  	 FreePool (RowInfoArray);
  	 RowInfoArray = NULL;
  }

  if (ColumnInfoArray != NULL) {
    FreePool (ColumnInfoArray);
    ColumnInfoArray = NULL;
  }

  //
  // 2. Check EFI_HII_OUT_FLAG_CLIP  
  //  
  Blt->Width = (UINT16) (HorizontalResolution);
  Blt->Height = (UINT16) (VerticalResolution);
  Blt->Image.Screen = GraphicsOutput; 
  StringInfo = NULL;
  //
  // String is designed to displayed at screen bottom with 2 pixel line cutted
  //
  BltX = 0;
  BltY = VerticalResolution - TestFontHeight + 2;
  Status = HIIFont->StringToImage (
                      HIIFont,
                      EFI_HII_OUT_FLAG_CLIP | EFI_HII_DIRECT_TO_SCREEN,
                      TestString,
                      StringInfo,
                      &Blt,
                      BltX,
                      BltY,
                      &RowInfoArray,
                      &RowInfoArraySize,
                      ColumnInfoArray
                      );
  
   //
   // For the final row, the RowInfoArray.LineHeight and RowInfoArray.BaseLine may describe pixels
   // which are outside the limit specified by Blt. Height (unless EFI_HII_OUT_FLAG_CLIP_CLEAN_Y 
   // is specified) even though those pixels were not drawn.
   //
  	if (EFI_SUCCESS == Status 
  		&& RowInfoArraySize == 1  
   	&& RowInfoArray != NULL
  	 && RowInfoArray[0].BaselineOffset == 0 
  	 && RowInfoArray[0].LineHeight == BltY + TestFontHeight - Blt->Height
  	 && RowInfoArray[0].LineWidth == Blt->Width
  	 && ColumnInfoArray != NULL) {
  	  AssertionType = EFI_TEST_ASSERTION_PASSED;
   } else {
     AssertionType = EFI_TEST_ASSERTION_FAILED;
   }

   StandardLib->RecordAssertion (
                  StandardLib,
                  AssertionType,
                  gHIIFontBBTestFunctionAssertionGuid010,
                  L"HII_FONT_PROTOCOL.StringToImage - StringToImage() EFI_HII_OUT_FLAG_CLIP fails.",
                  L"%a:%d: Status - %r",
                  __FILE__,
                  (UINTN)__LINE__,
                  Status
                  );
  if (RowInfoArray != NULL) {
  	 FreePool (RowInfoArray);
  	 RowInfoArray = NULL;
  }

  if (ColumnInfoArray != NULL) {
    FreePool (ColumnInfoArray);
    ColumnInfoArray = NULL;
  }

  //
  // 3. Check EFI_HII_OUT_FLAG_CLIP | EFI_HII_OUT_FLAG_CLIP_CLEAN_X
  //
  Blt->Width = (UINT16) (HorizontalResolution);
  Blt->Height = (UINT16) (VerticalResolution);
  Blt->Image.Screen = GraphicsOutput; 
  StringInfo = NULL;
  //
  // String is designed to displayed at screen bottom & cover all screen columns 
  //
  BltX = 0;
  BltY = VerticalResolution - 2 * TestFontHeight;
  Status = HIIFont->StringToImage (
                      HIIFont,
                      EFI_HII_OUT_FLAG_CLIP | EFI_HII_OUT_FLAG_CLIP_CLEAN_X | EFI_HII_DIRECT_TO_SCREEN ,
                      TestString,
                      StringInfo,
                      &Blt,
                      BltX,
                      BltY,
                      &RowInfoArray,
                      &RowInfoArraySize,
                      ColumnInfoArray
                      );
  //
  // if a character's right-most on pixel cannot fit, then it will not be drawn at all. 
  // This flag requires that EFI_HII_OUT_FLAG_CLIP be set
  //
  if (EFI_SUCCESS == Status 
  	&& RowInfoArraySize == 1  
  	&& RowInfoArray != NULL
   && RowInfoArray[0].BaselineOffset == 0 
   && RowInfoArray[0].LineHeight == TestFontHeight
   && RowInfoArray[0].LineWidth == (UINTN)(Blt->Width / TestFontWidth) * TestFontWidth
   && ColumnInfoArray != NULL) {
    AssertionType = EFI_TEST_ASSERTION_PASSED;
  } else {
    AssertionType = EFI_TEST_ASSERTION_FAILED;
  }

  StandardLib->RecordAssertion (
                 StandardLib,
                 AssertionType,
                 gHIIFontBBTestFunctionAssertionGuid011,
                 L"HII_FONT_PROTOCOL.StringToImage - StringToImage()",
                 L"EFI_HII_OUT_FLAG_CLIP | EFI_HII_OUT_FLAG_CLIP_CLEAN_X | EFI_HII_DIRECT_TO_SCREEN fails.",
                 L"%a:%d: Status - %r",
                 __FILE__,
                 (UINTN)__LINE__,
                 Status
                 );
  
  if (RowInfoArray != NULL) {
  	 FreePool (RowInfoArray);
  	 RowInfoArray = NULL;
  }

  if (ColumnInfoArray != NULL) {
    FreePool (ColumnInfoArray);
    ColumnInfoArray = NULL;
  }
    
  //
  // 4. Check EFI_HII_OUT_FLAG_CLIP | EFI_HII_OUT_FLAG_CLIP_CLEAN_Y
  //
  Blt->Width = (UINT16) (HorizontalResolution);
  Blt->Height = (UINT16) (VerticalResolution);
  Blt->Image.Screen = GraphicsOutput; 
  StringInfo = NULL;
  //
  // String is designed not to display at all since EFI_HII_OUT_FLAG_CLIP_CLEAN_Y is set
  //
  BltX = 0;
  BltY = VerticalResolution - TestFontHeight + 2;
  Status = HIIFont->StringToImage (
                      HIIFont,
                      EFI_HII_OUT_FLAG_CLIP | EFI_HII_OUT_FLAG_CLIP_CLEAN_Y | EFI_HII_DIRECT_TO_SCREEN ,
                      TestString,
                      StringInfo,
                      &Blt,
                      BltX,
                      BltY,
                      &RowInfoArray,
                      &RowInfoArraySize,
                      ColumnInfoArray
                      );
  //
  // if a row's bottom-most pixel cannot fit, then it will not be drawn at all.
  // This flag requires that EFI_HII_OUT_FLAG_CLIP be set.
  //
  if (EFI_SUCCESS == Status 
  	&& RowInfoArraySize == 1
   && RowInfoArray != NULL
  	&& RowInfoArray[0].LineHeight == 2
   && ColumnInfoArray != NULL) {
    AssertionType = EFI_TEST_ASSERTION_PASSED;
  } else {
    AssertionType = EFI_TEST_ASSERTION_FAILED;
  }
  StandardLib->RecordAssertion (
                 StandardLib,
                 AssertionType,
                 gHIIFontBBTestFunctionAssertionGuid012,
                 L"HII_FONT_PROTOCOL.StringToImage - StringToImage()",
                 L"EFI_HII_OUT_FLAG_CLIP | EFI_HII_OUT_FLAG_CLIP_CLEAN_Y | EFI_HII_DIRECT_TO_SCREEN fails."
                 L"%a:%d: Status - %r",
                 __FILE__,
                 (UINTN)__LINE__,
                 Status
                 );
  
  if (RowInfoArray != NULL) {
     FreePool (RowInfoArray);
     RowInfoArray = NULL;
  }

  if (ColumnInfoArray != NULL) {
    FreePool (ColumnInfoArray);
    ColumnInfoArray = NULL;
  }
  
  //
  // 5. Check EFI_HII_OUT_FLAG_WRAP 
  // 
  Blt->Width = (UINT16) (HorizontalResolution);
  Blt->Height = (UINT16) (VerticalResolution);
  Blt->Image.Screen = GraphicsOutput; 
  StringInfo = NULL;
  //
  // String is designed to show only 20 characters before line break
  //
  BltX = 0;
  BltY = VerticalResolution - 4*TestFontHeight;  
  TestString[20] = (CHAR16)0x2028; 
  Status = HIIFont->StringToImage (
                      HIIFont,
                      EFI_HII_OUT_FLAG_WRAP | EFI_HII_DIRECT_TO_SCREEN ,
                      TestString,
                      StringInfo,
                      &Blt,
                      BltX,
                      BltY,
                      &RowInfoArray,
                      &RowInfoArraySize,
                      ColumnInfoArray
                      );
  //
  // if a row's bottom-most pixel cannot fit, then it will not be drawn at all.
  // This flag requires that EFI_HII_OUT_FLAG_CLIP be set.
  //
  if (EFI_SUCCESS == Status 
  	&& RowInfoArraySize == 1
   && RowInfoArray != NULL
  	&& ColumnInfoArray != NULL) {
    AssertionType = EFI_TEST_ASSERTION_PASSED;
  } else {
    AssertionType = EFI_TEST_ASSERTION_FAILED;
  }
  StandardLib->RecordAssertion (
                 StandardLib,
                 AssertionType,
                 gHIIFontBBTestFunctionAssertionGuid013,
                 L"HII_FONT_PROTOCOL.StringToImage - StringToImage()",
                 L"EFI_HII_OUT_FLAG_WRAP | EFI_HII_DIRECT_TO_SCREEN fails."
                 L"%a:%d: Status - %r",
                 __FILE__,
                 (UINTN)__LINE__,
                 Status
                 );

  if (RowInfoArray != NULL) {
     FreePool (RowInfoArray);
     RowInfoArray = NULL;
  }

  if (ColumnInfoArray != NULL) {
    FreePool (ColumnInfoArray);
    ColumnInfoArray = NULL;
  }

  //
  // 6. Check EFI_HII_OUT_FLAG_WRAP | EFI_HII_OUT_FLAG_CLIP_CLEAN_Y
  //
  Blt->Width = (UINT16) (HorizontalResolution);
  Blt->Height = (UINT16) (VerticalResolution);
  Blt->Image.Screen = GraphicsOutput; 
  StringInfo = NULL;
  //
  //  String is designed not to display at all 
  //
  TestString[20] = (CHAR16)0x2028;   
  TestString[30] = (CHAR16)0x2028; 
  TestString[33] = L'\0';
  
  BltX = 0;
  BltY = VerticalResolution - TestFontHeight + 2;
  Status = HIIFont->StringToImage (
                      HIIFont,
                      EFI_HII_OUT_FLAG_WRAP | EFI_HII_OUT_FLAG_CLIP_CLEAN_Y | EFI_HII_DIRECT_TO_SCREEN,
                      TestString,
                      StringInfo,
                      &Blt,
                      BltX,
                      BltY,
                      &RowInfoArray,
                      &RowInfoArraySize,
                      ColumnInfoArray
                      );
  //
  // if a row's bottom-most pixel cannot fit, then it will not be drawn at all.
  // This flag requires that EFI_HII_OUT_FLAG_CLIP be set.
  //
  if (EFI_SUCCESS == Status 
   && RowInfoArraySize == 0 
   && ColumnInfoArray != NULL) {
    AssertionType = EFI_TEST_ASSERTION_PASSED;
  } else {
    AssertionType = EFI_TEST_ASSERTION_FAILED;
  }
  StandardLib->RecordAssertion (
                 StandardLib,
                 AssertionType,
                 gHIIFontBBTestFunctionAssertionGuid014,
                 L"HII_FONT_PROTOCOL.StringToImage - StringToImage()",
                 L"EFI_HII_OUT_FLAG_WRAP | EFI_HII_OUT_FLAG_CLIP_CLEAN_Y | EFI_HII_DIRECT_TO_SCREEN fails."
                 L"%a:%d: Status - %r",
                 __FILE__,
                 (UINTN)__LINE__,
                 Status
                 );
  
  if (RowInfoArray != NULL) {
     FreePool (RowInfoArray);
     RowInfoArray = NULL;
  }

  if (ColumnInfoArray != NULL) {
    FreePool (ColumnInfoArray);
    ColumnInfoArray = NULL;
  }
  
  //
  // 7. Check EFI_HII_OUT_FLAG_WRAP | EFI_HII_IGNORE_LINE_BREAK
  //
  
  Blt->Width = (UINT16) (HorizontalResolution);
  Blt->Height = (UINT16) (VerticalResolution);
  Blt->Image.Screen = GraphicsOutput; 
  StringInfo = NULL;
  //
  // String is designed to display 
  //
  for (Index = 0; Index < StrLen; Index++) {
    TestString[Index] = L'T';
  }
  TestString[StrLen] = L'\0';
  
  TestString[20] = (CHAR16)0x2028; 
  TestString[30] = (CHAR16)0x2028;
  BltX = 0;
  BltY = VerticalResolution - 4 * TestFontHeight;
  Status = HIIFont->StringToImage (
                      HIIFont,
                      EFI_HII_OUT_FLAG_WRAP | EFI_HII_IGNORE_LINE_BREAK | EFI_HII_DIRECT_TO_SCREEN,
                      TestString,
                      StringInfo,
                      &Blt,
                      BltX,
                      BltY,
                      &RowInfoArray,
                      &RowInfoArraySize,
                      ColumnInfoArray
                      );
  //
  // if a row's bottom-most pixel cannot fit, then it will not be drawn at all.
  // This flag requires that EFI_HII_OUT_FLAG_CLIP be set.
  //
  if (EFI_SUCCESS == Status 
   && RowInfoArraySize == 1
   && RowInfoArray != NULL
   && RowInfoArray[0].LineHeight == TestFontHeight
   && RowInfoArray[0].LineWidth == Blt->Width
   && ColumnInfoArray != NULL) {
    AssertionType = EFI_TEST_ASSERTION_PASSED;
  } else {
    AssertionType = EFI_TEST_ASSERTION_FAILED;
  }
  StandardLib->RecordAssertion (
                 StandardLib,
                 AssertionType,
                 gHIIFontBBTestFunctionAssertionGuid015,
                 L"HII_FONT_PROTOCOL.StringToImage - StringToImage()",
                 L"EFI_HII_OUT_FLAG_WRAP | EFI_HII_IGNORE_LINE_BREAK | EFI_HII_DIRECT_TO_SCREEN fails."
                 L"%a:%d: Status - %r",
                 __FILE__,
                 (UINTN)__LINE__,
                 Status
                 );
  
  
  if (RowInfoArray != NULL) {
     FreePool (RowInfoArray);
     RowInfoArray = NULL;
  }

  if (ColumnInfoArray != NULL) {
    FreePool (ColumnInfoArray);
    ColumnInfoArray = NULL;
  }

EXIT:
  if (Blt != NULL) {
    FreePool (Blt);
  }

  if (TestString != NULL) {
    FreePool (TestString);
  }
  
  return EFI_SUCCESS;
  
}


EFI_STATUS
BBTestStringToImageFunctionTestCheckpoint6 (
  IN EFI_STANDARD_TEST_LIBRARY_PROTOCOL         *StandardLib,
  IN EFI_HII_DATABASE_PROTOCOL                  *HIIDatabase,
  IN EFI_HII_FONT_PROTOCOL                      *HIIFont,
  IN EFI_GRAPHICS_OUTPUT_PROTOCOL               *GraphicsOutput
  )
{
  EFI_STATUS                          Status;
  EFI_TEST_ASSERTION                  AssertionType;
  EFI_STRING                          TestString = NULL;
  UINTN                               InfoSize;
  EFI_FONT_DISPLAY_INFO               *StringInfo = NULL;
  EFI_IMAGE_OUTPUT                    *Blt = NULL;
  UINTN                               BltX;
  UINTN                               BltY;
  EFI_HII_ROW_INFO                    *RowInfoArray = NULL;
  UINTN                               RowInfoArraySize;
  UINTN                               *ColumnInfoArray = NULL;
  UINT32                              HorizontalResolution;
  UINT32                              VerticalResolution;
  UINT32                              Index;
  UINT16                              TestFontHeight, TestFontWidth;
  UINT32                              StrLen;
  EFI_HII_PACKAGE_LIST_HEADER         *PackageList = NULL;
  EFI_HII_HANDLE                      HiiHandle = NULL;

  
  if ( GraphicsOutput != NULL ) {
    HorizontalResolution = GraphicsOutput->Mode->Info->HorizontalResolution;
    VerticalResolution = GraphicsOutput->Mode->Info->VerticalResolution;
  } else {
    return EFI_UNSUPPORTED;
  }

  
  //
  // Add the PackageList to the HII database to get a EFI_HII_HANDLE
  //
  PackageList = (EFI_HII_PACKAGE_LIST_HEADER*)mPackageListTestFont;

  Status = HIIDatabase->NewPackageList(
                          HIIDatabase,
                          PackageList,
                          NULL,
                          &HiiHandle
                          );
  if ( EFI_ERROR(Status) ) {
  	 StandardLib->RecordAssertion (
                   StandardLib,
                   EFI_TEST_ASSERTION_FAILED,
                   gTestGenericFailureGuid,
                   L"Test font packetlist add fail",
                   L"%a:%d: ",
                   __FILE__,
                   (UINTN)__LINE__
                   );
    return EFI_LOAD_ERROR;
  }

  InfoSize = sizeof (EFI_FONT_DISPLAY_INFO) - sizeof (CHAR16) + StrSize (L"testfont");
  StringInfo = (EFI_FONT_DISPLAY_INFO *) AllocateZeroPool (InfoSize);
  if (StringInfo == NULL) {
  	 StandardLib->RecordAssertion (
                   StandardLib,
                   EFI_TEST_ASSERTION_FAILED,
                   gTestGenericFailureGuid,
                   L"AllocateZeroPool fail",
                   L"%a:%d: ",
                   __FILE__,
                   (UINTN)__LINE__
                   );
    goto EXIT;  	  
  }
  

  StringInfo->BackgroundColor.Blue = 0x00;
  StringInfo->BackgroundColor.Red  = 0xFF;
  StringInfo->BackgroundColor.Green= 0x00;
  
  StringInfo->ForegroundColor.Blue = 0x00;
  StringInfo->ForegroundColor.Red  = 0x00;
  StringInfo->ForegroundColor.Green= 0xFF;
  
  StringInfo->FontInfoMask = EFI_FONT_INFO_ANY_STYLE;

  StringInfo->FontInfo.FontSize = 19;
  StringInfo->FontInfo.FontStyle = 0;  
  StrCpy (StringInfo->FontInfo.FontName, L"testfont");
  
  // 
  // Get Character 'T'  default system font as test character  
  //
  Status = HIIFont->GetGlyph (
  	                   HIIFont,
                      L'T',
                      StringInfo,
                      &Blt,
                      NULL
  	                   );
  if ( EFI_SUCCESS != Status ) {
    StandardLib->RecordAssertion (
                   StandardLib,
                   EFI_TEST_ASSERTION_FAILED,
                   gTestGenericFailureGuid,
                   L"GetGlyph fail",
                   L"%a:%d: Status - %r",
                   __FILE__,
                   (UINTN)__LINE__,
                   Status
                   );
    goto EXIT;
  }

  TestFontHeight = Blt->Height;
  TestFontWidth  = Blt->Width;
  FreePool(Blt);
  Blt = NULL;

  // 
  // Configure String Info 
  //

  //
  // Construct test string dynamically according to screen size  ( 4~5 charaters longer than screen width)
  // 
  TestString = (EFI_STRING)AllocateZeroPool(sizeof(L'T') * (HorizontalResolution / TestFontWidth + 5));
  if (TestString == NULL) {
    StandardLib->RecordAssertion (
                   StandardLib,
                   EFI_TEST_ASSERTION_FAILED,
                   gTestGenericFailureGuid,
                   L"AllocateZeroPool fail",
                   L"%a:%d: ",
                   __FILE__,
                   (UINTN)__LINE__
                   );
    goto EXIT;
  }
  
  StrLen = HorizontalResolution / TestFontWidth + 4;
  for (Index = 0; Index < StrLen; Index++) {
    TestString[Index] = L'T';
  }

  Blt = (EFI_IMAGE_OUTPUT *) AllocateZeroPool (sizeof(EFI_IMAGE_OUTPUT));
  if ( Blt == NULL ){
    goto EXIT;
  }

  //
  // 1. Check EFI_HII_DIRECT_TO_SCREEN only case
  // If Blt is not NULL, then EFI_HII_OUT_FLAG_CLIP is implied  
  // String is designed to displayed with one full line
  //
  Blt->Width = (UINT16) (HorizontalResolution);
  Blt->Height = (UINT16) (VerticalResolution);
  Blt->Image.Screen = GraphicsOutput; 

  BltX = 0;
  BltY = VerticalResolution - 3 * TestFontHeight;
  Status = HIIFont->StringToImage (
                      HIIFont,
                      EFI_HII_DIRECT_TO_SCREEN,
                      TestString,
                      StringInfo,
                      &Blt,
                      BltX,
                      BltY,
                      &RowInfoArray,
                      &RowInfoArraySize,
                      ColumnInfoArray
                      );
  
  //
  // For the final row, the RowInfoArray.LineHeight and RowInfoArray.BaseLine may describe pixels
  // which are outside the limit specified by Blt. Height (unless EFI_HII_OUT_FLAG_CLIP_CLEAN_Y 
  // is specified) even though those pixels were not drawn.
  //
  if (EFI_SUCCESS == Status 
  	&& RowInfoArraySize == 1    	
   && RowInfoArray != NULL
   && RowInfoArray[0].BaselineOffset == 0 
   && RowInfoArray[0].LineHeight == TestFontHeight
   && RowInfoArray[0].LineWidth == Blt->Width
   && ColumnInfoArray != NULL) {
    AssertionType = EFI_TEST_ASSERTION_PASSED;
  } else {
    AssertionType = EFI_TEST_ASSERTION_FAILED;
  }

  StandardLib->RecordAssertion (
                 StandardLib,
                 AssertionType,
                 gHIIFontBBTestFunctionAssertionGuid016,
                 L"HII_FONT_PROTOCOL.StringToImage - StringToImage() EFI_HII_DIRECT_TO_SCREEN fails.",
                 L"%a:%d: Status - %r",
                 __FILE__,
                 (UINTN)__LINE__,
                 Status
                 );
  if (RowInfoArray != NULL) {
  	 FreePool (RowInfoArray);
  	 RowInfoArray = NULL;
  }

  if (ColumnInfoArray != NULL) {
    FreePool (ColumnInfoArray);
    ColumnInfoArray = NULL;
  }

  //
  // 2. Check EFI_HII_OUT_FLAG_CLIP  
  //  
  Blt->Width = (UINT16) (HorizontalResolution);
  Blt->Height = (UINT16) (VerticalResolution);
  Blt->Image.Screen = GraphicsOutput; 
  //
  // String is designed to displayed at screen bottom with 2 pixel line cutted
  //
  BltX = 0;
  BltY = VerticalResolution - TestFontHeight + 2;
  Status = HIIFont->StringToImage (
                      HIIFont,
                      EFI_HII_OUT_FLAG_CLIP | EFI_HII_DIRECT_TO_SCREEN,
                      TestString,
                      StringInfo,
                      &Blt,
                      BltX,
                      BltY,
                      &RowInfoArray,
                      &RowInfoArraySize,
                      ColumnInfoArray
                      );
  
   //
   // For the final row, the RowInfoArray.LineHeight and RowInfoArray.BaseLine may describe pixels
   // which are outside the limit specified by Blt. Height (unless EFI_HII_OUT_FLAG_CLIP_CLEAN_Y 
   // is specified) even though those pixels were not drawn.
   //
  	if (EFI_SUCCESS == Status 
  		&& RowInfoArraySize == 1  
   	&& RowInfoArray != NULL
  	 && RowInfoArray[0].BaselineOffset == 0 
  	 && RowInfoArray[0].LineHeight == BltY + TestFontHeight - Blt->Height
  	 && RowInfoArray[0].LineWidth == Blt->Width
  	 && ColumnInfoArray != NULL) {
  	  AssertionType = EFI_TEST_ASSERTION_PASSED;
   } else {
     AssertionType = EFI_TEST_ASSERTION_FAILED;
   }

   StandardLib->RecordAssertion (
                  StandardLib,
                  AssertionType,
                  gHIIFontBBTestFunctionAssertionGuid017,
                  L"HII_FONT_PROTOCOL.StringToImage - StringToImage() EFI_HII_OUT_FLAG_CLIP fails.",
                  L"%a:%d: Status - %r",
                  __FILE__,
                  (UINTN)__LINE__,
                  Status
                  );
  if (RowInfoArray != NULL) {
  	 FreePool (RowInfoArray);
  	 RowInfoArray = NULL;
  }

  if (ColumnInfoArray != NULL) {
    FreePool (ColumnInfoArray);
    ColumnInfoArray = NULL;
  }

  //
  // 3. Check EFI_HII_OUT_FLAG_CLIP | EFI_HII_OUT_FLAG_CLIP_CLEAN_X
  //
  Blt->Width = (UINT16) (HorizontalResolution);
  Blt->Height = (UINT16) (VerticalResolution);
  Blt->Image.Screen = GraphicsOutput; 
  //
  // String is designed to displayed at screen bottom & cover all screen columns 
  //
  BltX = 0;
  BltY = VerticalResolution - 2 * TestFontHeight;
  Status = HIIFont->StringToImage (
                      HIIFont,
                      EFI_HII_OUT_FLAG_CLIP | EFI_HII_OUT_FLAG_CLIP_CLEAN_X | EFI_HII_DIRECT_TO_SCREEN ,
                      TestString,
                      StringInfo,
                      &Blt,
                      BltX,
                      BltY,
                      &RowInfoArray,
                      &RowInfoArraySize,
                      ColumnInfoArray
                      );
  //
  // if a character's right-most on pixel cannot fit, then it will not be drawn at all. 
  // This flag requires that EFI_HII_OUT_FLAG_CLIP be set
  //
  if (EFI_SUCCESS == Status 
  	&& RowInfoArraySize == 1  
  	&& RowInfoArray != NULL
   && RowInfoArray[0].BaselineOffset == 0 
   && RowInfoArray[0].LineHeight == TestFontHeight
   && RowInfoArray[0].LineWidth == (UINTN)(Blt->Width / TestFontWidth) * TestFontWidth
   && ColumnInfoArray != NULL) {
    AssertionType = EFI_TEST_ASSERTION_PASSED;
  } else {
    AssertionType = EFI_TEST_ASSERTION_FAILED;
  }

  StandardLib->RecordAssertion (
                 StandardLib,
                 AssertionType,
                 gHIIFontBBTestFunctionAssertionGuid018,
                 L"HII_FONT_PROTOCOL.StringToImage - StringToImage()",
                 L"EFI_HII_OUT_FLAG_CLIP | EFI_HII_OUT_FLAG_CLIP_CLEAN_X | EFI_HII_DIRECT_TO_SCREEN fails.",
                 L"%a:%d: Status - %r",
                 __FILE__,
                 (UINTN)__LINE__,
                 Status
                 );
  
  if (RowInfoArray != NULL) {
  	 FreePool (RowInfoArray);
  	 RowInfoArray = NULL;
  }

  if (ColumnInfoArray != NULL) {
    FreePool (ColumnInfoArray);
    ColumnInfoArray = NULL;
  }
    
  //
  // 4. Check EFI_HII_OUT_FLAG_CLIP | EFI_HII_OUT_FLAG_CLIP_CLEAN_Y
  //
  Blt->Width = (UINT16) (HorizontalResolution);
  Blt->Height = (UINT16) (VerticalResolution);
  Blt->Image.Screen = GraphicsOutput; 
  //
  // String is designed not to display at all since EFI_HII_OUT_FLAG_CLIP_CLEAN_Y is set
  //
  BltX = 0;
  BltY = VerticalResolution - TestFontHeight + 2;
  Status = HIIFont->StringToImage (
                      HIIFont,
                      EFI_HII_OUT_FLAG_CLIP | EFI_HII_OUT_FLAG_CLIP_CLEAN_Y | EFI_HII_DIRECT_TO_SCREEN ,
                      TestString,
                      StringInfo,
                      &Blt,
                      BltX,
                      BltY,
                      &RowInfoArray,
                      &RowInfoArraySize,
                      ColumnInfoArray
                      );
  //
  // if a row's bottom-most pixel cannot fit, then it will not be drawn at all.
  // This flag requires that EFI_HII_OUT_FLAG_CLIP be set.
  //
  if (EFI_SUCCESS == Status 
  	&& RowInfoArraySize == 1
   && RowInfoArray != NULL
  	&& RowInfoArray[0].LineHeight == 2
   && ColumnInfoArray != NULL) {
    AssertionType = EFI_TEST_ASSERTION_PASSED;
  } else {
    AssertionType = EFI_TEST_ASSERTION_FAILED;
  }
  StandardLib->RecordAssertion (
                 StandardLib,
                 AssertionType,
                 gHIIFontBBTestFunctionAssertionGuid019,
                 L"HII_FONT_PROTOCOL.StringToImage - StringToImage()",
                 L"EFI_HII_OUT_FLAG_CLIP | EFI_HII_OUT_FLAG_CLIP_CLEAN_Y | EFI_HII_DIRECT_TO_SCREEN fails."
                 L"%a:%d: Status - %r",
                 __FILE__,
                 (UINTN)__LINE__,
                 Status
                 );
  
  if (RowInfoArray != NULL) {
     FreePool (RowInfoArray);
     RowInfoArray = NULL;
  }

  if (ColumnInfoArray != NULL) {
    FreePool (ColumnInfoArray);
    ColumnInfoArray = NULL;
  }
  
  //
  // 5. Check EFI_HII_OUT_FLAG_WRAP 
  // 
  Blt->Width = (UINT16) (HorizontalResolution);
  Blt->Height = (UINT16) (VerticalResolution);
  Blt->Image.Screen = GraphicsOutput; 
  //
  // String is designed to show only 20 characters before line break
  //
  BltX = 0;
  BltY = VerticalResolution - 4*TestFontHeight;  
  TestString[20] = (CHAR16)0x2028; 
  Status = HIIFont->StringToImage (
                      HIIFont,
                      EFI_HII_OUT_FLAG_WRAP | EFI_HII_DIRECT_TO_SCREEN ,
                      TestString,
                      StringInfo,
                      &Blt,
                      BltX,
                      BltY,
                      &RowInfoArray,
                      &RowInfoArraySize,
                      ColumnInfoArray
                      );
  //
  // if a row's bottom-most pixel cannot fit, then it will not be drawn at all.
  // This flag requires that EFI_HII_OUT_FLAG_CLIP be set.
  //
  if (EFI_SUCCESS == Status 
  	&& RowInfoArraySize == 1
   && RowInfoArray != NULL
  	&& ColumnInfoArray != NULL) {
    AssertionType = EFI_TEST_ASSERTION_PASSED;
  } else {
    AssertionType = EFI_TEST_ASSERTION_FAILED;
  }
  StandardLib->RecordAssertion (
                 StandardLib,
                 AssertionType,
                 gHIIFontBBTestFunctionAssertionGuid020,
                 L"HII_FONT_PROTOCOL.StringToImage - StringToImage()",
                 L"EFI_HII_OUT_FLAG_WRAP | EFI_HII_DIRECT_TO_SCREEN fails."
                 L"%a:%d: Status - %r",
                 __FILE__,
                 (UINTN)__LINE__,
                 Status
                 );

  if (RowInfoArray != NULL) {
     FreePool (RowInfoArray);
     RowInfoArray = NULL;
  }

  if (ColumnInfoArray != NULL) {
    FreePool (ColumnInfoArray);
    ColumnInfoArray = NULL;
  }

  //
  // 6. Check EFI_HII_OUT_FLAG_WRAP | EFI_HII_OUT_FLAG_CLIP_CLEAN_Y
  //
  Blt->Width = (UINT16) (HorizontalResolution);
  Blt->Height = (UINT16) (VerticalResolution);
  Blt->Image.Screen = GraphicsOutput; 
  //
  //  String is designed not to display at all 
  //
  TestString[20] = (CHAR16)0x2028;   
  TestString[30] = (CHAR16)0x2028; 
  TestString[33] = L'\0';
  
  BltX = 0;
  BltY = VerticalResolution - TestFontHeight + 2;
  Status = HIIFont->StringToImage (
                      HIIFont,
                      EFI_HII_OUT_FLAG_WRAP | EFI_HII_OUT_FLAG_CLIP_CLEAN_Y | EFI_HII_DIRECT_TO_SCREEN,
                      TestString,
                      StringInfo,
                      &Blt,
                      BltX,
                      BltY,
                      &RowInfoArray,
                      &RowInfoArraySize,
                      ColumnInfoArray
                      );
  //
  // if a row's bottom-most pixel cannot fit, then it will not be drawn at all.
  // This flag requires that EFI_HII_OUT_FLAG_CLIP be set.
  //
  if (EFI_SUCCESS == Status 
   && RowInfoArraySize == 0 
   && ColumnInfoArray != NULL) {
    AssertionType = EFI_TEST_ASSERTION_PASSED;
  } else {
    AssertionType = EFI_TEST_ASSERTION_FAILED;
  }
  StandardLib->RecordAssertion (
                 StandardLib,
                 AssertionType,
                 gHIIFontBBTestFunctionAssertionGuid021,
                 L"HII_FONT_PROTOCOL.StringToImage - StringToImage()",
                 L"EFI_HII_OUT_FLAG_WRAP | EFI_HII_OUT_FLAG_CLIP_CLEAN_Y | EFI_HII_DIRECT_TO_SCREEN fails."
                 L"%a:%d: Status - %r",
                 __FILE__,
                 (UINTN)__LINE__,
                 Status
                 );
  
  if (RowInfoArray != NULL) {
     FreePool (RowInfoArray);
     RowInfoArray = NULL;
  }

  if (ColumnInfoArray != NULL) {
    FreePool (ColumnInfoArray);
    ColumnInfoArray = NULL;
  }
  
  //
  // 7. Check EFI_HII_OUT_FLAG_WRAP | EFI_HII_IGNORE_LINE_BREAK
  //
  
  Blt->Width = (UINT16) (HorizontalResolution);
  Blt->Height = (UINT16) (VerticalResolution);
  Blt->Image.Screen = GraphicsOutput; 
  //
  // String is designed to display 
  //
  for (Index = 0; Index < StrLen; Index++) {
    TestString[Index] = L'T';
  }
  TestString[StrLen] = L'\0';
  
  TestString[20] = (CHAR16)0x2028; 
  TestString[30] = (CHAR16)0x2028;
  BltX = 0;
  BltY = VerticalResolution - 4 * TestFontHeight;
  Status = HIIFont->StringToImage (
                      HIIFont,
                      EFI_HII_OUT_FLAG_WRAP | EFI_HII_IGNORE_LINE_BREAK | EFI_HII_DIRECT_TO_SCREEN,
                      TestString,
                      StringInfo,
                      &Blt,
                      BltX,
                      BltY,
                      &RowInfoArray,
                      &RowInfoArraySize,
                      ColumnInfoArray
                      );
  //
  // if a row's bottom-most pixel cannot fit, then it will not be drawn at all.
  // This flag requires that EFI_HII_OUT_FLAG_CLIP be set.
  //
  if (EFI_SUCCESS == Status 
   && RowInfoArraySize == 1
   && RowInfoArray != NULL
   && RowInfoArray[0].LineHeight == TestFontHeight
   && RowInfoArray[0].LineWidth == Blt->Width
   && ColumnInfoArray != NULL) {
    AssertionType = EFI_TEST_ASSERTION_PASSED;
  } else {
    AssertionType = EFI_TEST_ASSERTION_FAILED;
  }
  StandardLib->RecordAssertion (
                 StandardLib,
                 AssertionType,
                 gHIIFontBBTestFunctionAssertionGuid022,
                 L"HII_FONT_PROTOCOL.StringToImage - StringToImage()",
                 L"EFI_HII_OUT_FLAG_WRAP | EFI_HII_IGNORE_LINE_BREAK | EFI_HII_DIRECT_TO_SCREEN fails."
                 L"%a:%d: Status - %r",
                 __FILE__,
                 (UINTN)__LINE__,
                 Status
                 );
  
  
  if (RowInfoArray != NULL) {
     FreePool (RowInfoArray);
     RowInfoArray = NULL;
  }

  if (ColumnInfoArray != NULL) {
    FreePool (ColumnInfoArray);
    ColumnInfoArray = NULL;
  }

EXIT:
 	//
  // remove test font package
  //
  if (HiiHandle != NULL) {
    HIIDatabase->RemovePackageList (
                   HIIDatabase,
                   HiiHandle
                   );
  }
  
	 if (StringInfo != NULL) {
    FreePool (StringInfo);
	 }
	 
  if (Blt != NULL) {
    FreePool (Blt);
  }

  if (TestString != NULL) {
    FreePool (TestString);
  }
  
  return EFI_SUCCESS;
  
}



EFI_STATUS
BBTestStringIdToImageFunctionTestCheckpoint1 (
  IN EFI_STANDARD_TEST_LIBRARY_PROTOCOL         *StandardLib,
  IN EFI_HII_DATABASE_PROTOCOL                  *HIIDatabase,
  IN EFI_HII_STRING_PROTOCOL                    *HIIString,
  IN EFI_HII_FONT_PROTOCOL                      *HIIFont
  )
{
  EFI_STATUS            Status;
  EFI_TEST_ASSERTION    AssertionType;

  EFI_HII_HANDLE                 Handle;
  EFI_HII_PACKAGE_LIST_HEADER    *PackageList;
  UINTN                          Index;
  
  EFI_STRING_ID            StringId;
  CHAR8                    *Language;
  CHAR16                   *LanguageName;
  EFI_FONT_DISPLAY_INFO    *StringInfo;
  EFI_IMAGE_OUTPUT         *Blt;
  UINTN                    BltX;
  UINTN                    BltY;

  EFI_STRING               TestString;
  EFI_HII_ROW_INFO         **RowInfoArray = NULL;
  UINTN                    *RowInfoArraySize = NULL;
  UINTN                    *ColumnInfoArray = NULL;

  EFI_HII_OUT_FLAGS ValidFlags[] = {
    EFI_HII_OUT_FLAG_CLIP, 
    EFI_HII_OUT_FLAG_WRAP,
    EFI_HII_OUT_FLAG_CLIP_CLEAN_Y | EFI_HII_OUT_FLAG_CLIP,
    EFI_HII_OUT_FLAG_CLIP_CLEAN_X | EFI_HII_OUT_FLAG_CLIP,
    EFI_HII_OUT_FLAG_TRANSPARENT,
    EFI_HII_IGNORE_IF_NO_GLYPH,
    EFI_HII_IGNORE_LINE_BREAK,
    0
  };
  
  //
  // Allocate Memory
  //
  Blt = (EFI_IMAGE_OUTPUT *) AllocateZeroPool (sizeof(EFI_IMAGE_OUTPUT));
  if ( Blt == NULL ){
    return  EFI_UNSUPPORTED;
  }

  Blt->Width = 50;
  Blt->Height = 40;
  Blt->Image.Bitmap = (EFI_GRAPHICS_OUTPUT_BLT_PIXEL *)AllocateZeroPool (Blt->Width *Blt->Height * sizeof(EFI_GRAPHICS_OUTPUT_BLT_PIXEL));
  if ( Blt->Image.Bitmap == NULL ){
  	gtBS->FreePool (Blt);
    return  EFI_UNSUPPORTED;
  } 

  //
  // Add the PackageList to the HII database to get a EFI_HII_HANDLE
  //
  PackageList = (EFI_HII_PACKAGE_LIST_HEADER*)mPackageList1;

  Status = HIIDatabase->NewPackageList(
                          HIIDatabase,
                          PackageList,
                          NULL,
                          &Handle
                          );
  if ( EFI_ERROR(Status) ) {
    return Status;
  }

  //
  // Add a String to the PackageList to get a StringId
  //
  Language = "en-US";
  TestString = L"TestString";
  LanguageName = L"English(United States)";
  Status = HIIString->NewString(
                        HIIString,
                        Handle,
                        &StringId,
                        Language,
                        LanguageName,
                        TestString,
                        NULL);
  if ( EFI_ERROR(Status) ) {
    return Status;
  }
  
  StringInfo = NULL;
  BltX = 0;
  BltY = 0;
  
  //
  // Call HIIFont->StringIdToImage with valid parameters
  //
  for ( Index = 0; ValidFlags[Index] != 0; Index++ ){
    Status = HIIFont->StringIdToImage (
                        HIIFont,
                        ValidFlags[Index],
                        Handle,
                        StringId,
                        Language,
                        StringInfo,
                        &Blt,
                        BltX,
                        BltY,
                        RowInfoArray,
                        RowInfoArraySize,
                        ColumnInfoArray
                        );
                            

    if ( EFI_SUCCESS != Status ) {
      AssertionType = EFI_TEST_ASSERTION_FAILED;
    } else {
      AssertionType = EFI_TEST_ASSERTION_PASSED;
    }
    StandardLib->RecordAssertion (
                   StandardLib,
                   AssertionType,
                   gHIIFontBBTestFunctionAssertionGuid003,
                   L"HII_FONT_PROTOCOL.StringIdToImage - StringIdToImage() returns EFI_SUCCESS with valid parameters.",
                   L"%a:%d: Status - %r",
                   __FILE__,
                   (UINTN)__LINE__,
                   Status
                   );

	if (RowInfoArray != NULL)
		gtBS->FreePool (RowInfoArray);
  }

  gtBS->FreePool (Blt->Image.Bitmap);
  gtBS->FreePool (Blt);

  //
  // Remove the PackageList from the HII database
  //
  Status = HIIDatabase->RemovePackageList (
                          HIIDatabase,
                          Handle
                          );

  return EFI_SUCCESS;
}


EFI_STATUS
BBTestStringIdToImageFunctionTestCheckpoint2 (
  IN EFI_STANDARD_TEST_LIBRARY_PROTOCOL         *StandardLib,
  IN EFI_HII_DATABASE_PROTOCOL                  *HIIDatabase,
  IN EFI_HII_STRING_PROTOCOL                    *HIIString,
  IN EFI_HII_FONT_PROTOCOL                      *HIIFont,
  IN EFI_GRAPHICS_OUTPUT_PROTOCOL               *GraphicsOutput
  )
{
  EFI_STATUS            Status;
  EFI_TEST_ASSERTION    AssertionType;

  EFI_HII_HANDLE                 Handle;
  EFI_HII_PACKAGE_LIST_HEADER    *PackageList;
  UINTN                          Index;
  
  EFI_STRING_ID            StringId;
  CHAR8                    *Language;
  CHAR16                   *LanguageName;
  EFI_FONT_DISPLAY_INFO    *StringInfo;
  EFI_IMAGE_OUTPUT         *Blt;
  UINTN                    BltX;
  UINTN                    BltY;

  EFI_STRING               TestString;
  EFI_HII_ROW_INFO         **RowInfoArray = NULL;
  UINTN                    *RowInfoArraySize = NULL;
  UINTN                    *ColumnInfoArray = NULL;
  
  UINT32                   HorizontalResolution;
  UINT32                   VerticalResolution;
  

  EFI_HII_OUT_FLAGS ValidFlags[] = {
    EFI_HII_OUT_FLAG_CLIP | EFI_HII_DIRECT_TO_SCREEN, 
    EFI_HII_OUT_FLAG_WRAP | EFI_HII_DIRECT_TO_SCREEN,
    EFI_HII_OUT_FLAG_CLIP_CLEAN_Y | EFI_HII_OUT_FLAG_CLIP | EFI_HII_DIRECT_TO_SCREEN,
    EFI_HII_OUT_FLAG_CLIP_CLEAN_X | EFI_HII_OUT_FLAG_CLIP | EFI_HII_DIRECT_TO_SCREEN,
    EFI_HII_IGNORE_IF_NO_GLYPH | EFI_HII_DIRECT_TO_SCREEN,
    EFI_HII_IGNORE_LINE_BREAK | EFI_HII_DIRECT_TO_SCREEN,
    EFI_HII_DIRECT_TO_SCREEN,
    0
  };

  if ( GraphicsOutput != NULL ) {
    HorizontalResolution = GraphicsOutput->Mode->Info->HorizontalResolution;
    VerticalResolution = GraphicsOutput->Mode->Info->VerticalResolution;
  } else {
    return EFI_UNSUPPORTED;
  }

  //
  // Add the PackageList to the HII database to get a EFI_HII_HANDLE
  //
  PackageList = (EFI_HII_PACKAGE_LIST_HEADER*)mPackageList1;

  Status = HIIDatabase->NewPackageList(
                          HIIDatabase,
                          PackageList,
                          NULL,
                          &Handle
                          );
  if ( EFI_ERROR(Status) ) {
    return Status;
  }

  //
  // Add a String to the PackageList to get a StringId
  //
  Language = "en-US";
  TestString = L"TestString";
  LanguageName = L"English(United States)";
  Status = HIIString->NewString(
                        HIIString,
                        Handle,
                        &StringId,
                        Language,
                        LanguageName,
                        TestString,
                        NULL);
  if ( EFI_ERROR(Status) ) {
    return Status;
  }

  //
  // Allocate Memory
  //
  Blt = (EFI_IMAGE_OUTPUT *) AllocateZeroPool (sizeof(EFI_IMAGE_OUTPUT));
  if ( Blt == NULL ){
    return  EFI_UNSUPPORTED;
  }
  
  
  StringInfo = NULL;
  Blt->Width = (UINT16) (HorizontalResolution);
  Blt->Height = (UINT16) (VerticalResolution);
  Blt->Image.Screen = GraphicsOutput;
  BltX = 0;
  BltY = 0;
  
  //
  // Call HIIFont->StringIdToImage with valid parameters
  //
  for ( Index = 0; ValidFlags[Index] != 0; Index++ ){
    Status = HIIFont->StringIdToImage (
                        HIIFont,
                        ValidFlags[Index],
                        Handle,
                        StringId,
                        Language,
                        StringInfo,
                        &Blt,
                        BltX,
                        BltY,
                        RowInfoArray,
                        RowInfoArraySize,
                        ColumnInfoArray
                        );
                            

    if ( EFI_SUCCESS != Status ) {
      AssertionType = EFI_TEST_ASSERTION_FAILED;
    } else {
      AssertionType = EFI_TEST_ASSERTION_PASSED;
    }
    StandardLib->RecordAssertion (
                   StandardLib,
                   AssertionType,
                   gHIIFontBBTestFunctionAssertionGuid004,
                   L"HII_FONT_PROTOCOL.StringIdToImage - StringIdToImage() returns EFI_SUCCESS with valid parameters.",
                   L"%a:%d: Status - %r",
                   __FILE__,
                   (UINTN)__LINE__,
                   Status
                   );

	if ( RowInfoArray != NULL )
		gtBS->FreePool (RowInfoArray);
  }

  gtBS->FreePool (Blt);

  //
  // Remove the PackageList from the HII database
  //
  Status = HIIDatabase->RemovePackageList (
                          HIIDatabase,
                          Handle
                          );

  return EFI_SUCCESS;
}


EFI_STATUS
BBTestGetGlyphFunctionTestCheckpoint1 (
  IN EFI_STANDARD_TEST_LIBRARY_PROTOCOL         *StandardLib,
  IN EFI_HII_FONT_PROTOCOL                      *HIIFont
  )
{
  EFI_STATUS            Status;
  EFI_TEST_ASSERTION    AssertionType;
  
  CHAR16                   Char = L'A';
  EFI_FONT_DISPLAY_INFO    *StringInfo = NULL;
  EFI_IMAGE_OUTPUT         *Blt = NULL;
  UINTN                    Baseline = 0;
  
  //
  // Call GetGlyph with valid parameters
  //
  Status = HIIFont->GetGlyph (
                      HIIFont,
                      Char,
                      StringInfo,
                      &Blt,
                      &Baseline
                      );

  if ( EFI_SUCCESS == Status ){
    AssertionType = EFI_TEST_ASSERTION_PASSED;
  }else if ( EFI_WARN_UNKNOWN_GLYPH == Status ){
    AssertionType = EFI_TEST_ASSERTION_WARNING;
  }else if ( EFI_OUT_OF_RESOURCES == Status ) {
    AssertionType = EFI_TEST_ASSERTION_WARNING;
  } else {
    AssertionType = EFI_TEST_ASSERTION_FAILED;

  }
  StandardLib->RecordAssertion (
                 StandardLib,
                 AssertionType,
                 gHIIFontBBTestFunctionAssertionGuid005,
                 L"HII_FONT_PROTOCOL.GetGlyph - GetGlyph() returns EFI_SUCCESS with valid parameters.",
                 L"%a:%d: Status - %r",
                 __FILE__,
                 (UINTN)__LINE__,
                 Status
                 );
  
  if ( EFI_SUCCESS == Status ){
  	gtBS->FreePool (Blt->Image.Bitmap);
    gtBS->FreePool (Blt);
  }

  return EFI_SUCCESS;
}


EFI_STATUS
BBTestGetFontInfoFunctionTestCheckpoint1 (
  IN EFI_STANDARD_TEST_LIBRARY_PROTOCOL         *StandardLib,
  IN EFI_HII_FONT_PROTOCOL                      *HIIFont
  )
{

  EFI_STATUS            Status;
  EFI_TEST_ASSERTION    AssertionType;
  
  EFI_FONT_DISPLAY_INFO    *StringInfoIn;
  EFI_FONT_DISPLAY_INFO    *StringInfoOut;
  EFI_STRING               String = L"TestString";
  EFI_FONT_HANDLE          FontHandle = NULL;

  StringInfoOut = NULL;
  //
  // Init 
  StringInfoIn = (EFI_FONT_DISPLAY_INFO *) AllocateZeroPool (sizeof(EFI_FONT_DISPLAY_INFO));
  if ( StringInfoIn == NULL ){
    return  EFI_UNSUPPORTED;
  }
  
  StringInfoIn->FontInfo.FontStyle = EFI_FONT_INFO_SYS_FONT;
  StringInfoIn->FontInfo.FontSize = 20;
  StringInfoIn->ForegroundColor.Blue= 0;
  StringInfoIn->ForegroundColor.Green = 0;
  StringInfoIn->ForegroundColor.Red = 0;
  StringInfoIn->BackgroundColor.Blue = 150;
  StringInfoIn->BackgroundColor.Green = 150;
  StringInfoIn->BackgroundColor.Red = 150;
  StringInfoIn->FontInfoMask = EFI_FONT_INFO_SYS_FONT | EFI_FONT_INFO_SYS_SIZE | EFI_FONT_INFO_SYS_STYLE | \
                               EFI_FONT_INFO_SYS_FORE_COLOR | EFI_FONT_INFO_SYS_BACK_COLOR;

  Status = EFI_SUCCESS;

  while( !EFI_ERROR(Status) ){

    Status = HIIFont->GetFontInfo (
                        HIIFont,
                        &FontHandle,
                        StringInfoIn,
                        &StringInfoOut,
                        String
                        );
	
    if ( StringInfoOut != NULL ) {
      gtBS->FreePool (StringInfoOut);
      StringInfoOut = NULL;
    }
  }	
  
  if ( (EFI_NOT_FOUND == Status && NULL == FontHandle) || EFI_OUT_OF_RESOURCES == Status) {
    AssertionType = EFI_TEST_ASSERTION_PASSED;
  } else {
    AssertionType = EFI_TEST_ASSERTION_FAILED;
  }
  
  StandardLib->RecordAssertion (
                 StandardLib,
                 AssertionType,
                 gHIIFontBBTestFunctionAssertionGuid006,
                 L"HII_FONT_PROTOCOL.GetFont - GetFont() returns EFI_SUCCESS with valid parameters.",
                 L"%a:%d: Status - %r",
                 __FILE__,
                 (UINTN)__LINE__,
                 Status
                 );
  
  gtBS->FreePool (StringInfoIn);

  return EFI_SUCCESS;
}


EFI_STATUS
BBTestGetFontInfoFunctionTestCheckpoint2 (
  IN EFI_STANDARD_TEST_LIBRARY_PROTOCOL         *StandardLib,
  IN EFI_HII_FONT_PROTOCOL                      *HIIFont
  )
{

  EFI_STATUS            Status;
  EFI_TEST_ASSERTION    AssertionType;
  
  EFI_FONT_DISPLAY_INFO    *StringInfoIn;
  EFI_FONT_DISPLAY_INFO    *StringInfoOut;
  EFI_STRING               String = L"TestString";
  EFI_FONT_HANDLE          FontHandle = NULL;


  //When StringInfoIn is NULL, the default system font and color should be returned.
  StringInfoIn = NULL;
  StringInfoOut = NULL;

  Status = EFI_SUCCESS;

  while( !EFI_ERROR(Status) ){

    Status = HIIFont->GetFontInfo (
                        HIIFont,
                        &FontHandle,
                        StringInfoIn,
                        &StringInfoOut,
                        String
                        );
	
    if ( StringInfoOut != NULL ) {
      gtBS->FreePool (StringInfoOut);
      StringInfoOut = NULL;	  
    }
  }	

  
  if ( (EFI_NOT_FOUND == Status && NULL == FontHandle) || EFI_OUT_OF_RESOURCES == Status) {
    AssertionType = EFI_TEST_ASSERTION_PASSED;
  } else {
    AssertionType = EFI_TEST_ASSERTION_FAILED;
  }
  
  StandardLib->RecordAssertion (
                 StandardLib,
                 AssertionType,
                 gHIIFontBBTestFunctionAssertionGuid007,
                 L"HII_FONT_PROTOCOL.GetFont - GetFont() returns EFI_SUCCESS with valid parameters.",
                 L"%a:%d: Status - %r",
                 __FILE__,
                 (UINTN)__LINE__,
                 Status
                 );

  return EFI_SUCCESS;
}

